| Version: 3.3.1

Public Member Functions | Static Public Member Functions | List of all members
wxFileName Class Reference
Class List by Category » File Handling

`#include <wx/filename.h>`

## Detailed Description

wxFileName encapsulates a file name.

This class serves two purposes: first, it provides the functions to split the file names into components and to recombine these components in the full file name which can then be passed to the OS file functions (and wxWidgets functions wrapping them). Second, it includes the functions for working with the files itself. Note that to change the file data you should use wxFile class instead. wxFileName provides functions for working with the file attributes.

When working with directory names (i.e. without filename and extension) make sure not to misuse the file name part of this class with the last directory. Instead initialize the wxFileName instance like this:

wxFileName dirname( "C:\\mydir", "" );
MyMethod( dirname.GetPath() );
wxFileName
wxFileName encapsulates a file name.
Definition: filename.h:343

The same can be done using the static method wxFileName::DirName():

wxFileName dirname = wxFileName::DirName( "C:\\mydir" );
MyMethod( dirname.GetPath() );
wxFileName::GetPath
wxString GetPath(int flags=wxPATH_GET_VOLUME, wxPathFormat format=wxPATH_NATIVE) const
Returns the path part of the filename (without the name or extension).
wxFileName::DirName
static wxFileName DirName(const wxString &dir, wxPathFormat format=wxPATH_NATIVE)
Returns the object corresponding to the directory with the given name.

Accordingly, methods dealing with directories or directory names like wxFileName::IsDirReadable() use wxFileName::GetPath() whereas methods dealing with file names like wxFileName::IsFileReadable() use wxFileName::GetFullPath().

If it is not known whether a string contains a directory name or a complete file name (such as when interpreting user input) you need to use the static function wxFileName::DirExists() (or its identical variants wxDir::Exists() and wxDirExists()) and construct the wxFileName instance accordingly. This will only work if the directory actually exists, of course:

wxString user_input;
// get input from user
wxFileName fname;
if (wxDirExists(user_input))
fname.AssignDir( user_input );
else
fname.Assign( user_input );
wxFileName::AssignDir
void AssignDir(const wxString &dir, wxPathFormat format=wxPATH_NATIVE)
Sets this file name object to the given directory name.
wxFileName::Assign
void Assign(const wxFileName &filepath)
Creates the file name from another filename object.
wxString
String class for passing textual data to or receiving it from wxWidgets.
Definition: string.h:372
wxDirExists
bool wxDirExists(const wxString &dirname)
Returns true if dirname exists and is a directory.

Please note that many wxFileName methods accept the path format argument which is by `wxPATH_NATIVE` by default meaning to use the path format native for the current platform. The path format affects the operation of wxFileName functions in several ways: first and foremost, it defines the path separator character to use, but it also affects other things such as whether the path has the drive part or not. See wxPathFormat for more info.

# File name format

wxFileName currently supports the file names in the Unix, DOS/Windows, Mac OS and VMS formats. Although these formats are quite different, wxFileName tries to treat them all in the same generic way. It supposes that all file names consist of the following parts: the volume (also known as drive under Windows or device under VMS), the path which is a sequence of directory names separated by the path separators and the full filename itself which, in turn, is composed from the base file name and the extension. All of the individual components of the file name may be empty and, for example, the volume name is always empty under Unix, but if they are all empty simultaneously, the filename object is considered to be in an invalid state and wxFileName::IsOk() returns false for it.

File names can be case-sensitive or not, the function wxFileName::IsCaseSensitive() allows determining this. The rules for determining whether the file name is absolute or relative also depend on the file name format and the only portable way to answer this question is to use wxFileName::IsAbsolute() or wxFileName::IsRelative() method.

Note that on Windows,"X:" refers to the current working directory on drive X. Therefore, a wxFileName instance constructed from for example "X:dir/file.ext" treats the portion beyond drive separator as being relative to that directory. To ensure that the filename is absolute, you may use wxFileName::MakeAbsolute(). There is also an inverse function wxFileName::MakeRelativeTo() which undoes what wxFileName::Normalize(wxPATH_NORM_DOTS) does. Other functions returning information about the file format provided by this class are wxFileName::GetVolumeSeparator(), wxFileName::IsPathSeparator().

# File name construction

You can initialize a wxFileName instance using one of the following functions:

- wxFileName::wxFileName()
- wxFileName::Assign()
- wxFileName::AssignCwd()
- wxFileName::AssignDir()
- wxFileName::AssignHomeDir()
- wxFileName::AssignTempFileName()
- wxFileName::DirName()
- wxFileName::FileName()
- wxFileName::operator=()

# File name tests

Before doing other tests, you should use wxFileName::IsOk() to verify that the filename is well defined. If it is, FileExists() can be used to test whether a file with such name exists and wxFileName::DirExists() can be used to test for directory existence. File names should be compared using the wxFileName::SameAs() method or wxFileName::operator==(). For testing basic access modes, you can use:

- wxFileName::IsDirWritable()
- wxFileName::IsDirReadable()
- wxFileName::IsFileWritable()
- wxFileName::IsFileReadable()
- wxFileName::IsFileExecutable()

# File name components

These functions allow to examine and modify the individual directories of the path:

- wxFileName::AppendDir()
- wxFileName::InsertDir()
- wxFileName::GetDirCount()
- wxFileName::PrependDir()
- wxFileName::RemoveDir()
- wxFileName::RemoveLastDir()

To change the components of the file name individually you can use the following functions:

- wxFileName::GetExt()
- wxFileName::GetName()
- wxFileName::GetVolume()
- wxFileName::HasExt()
- wxFileName::HasName()
- wxFileName::HasVolume()
- wxFileName::SetExt()
- wxFileName::ClearExt()
- wxFileName::SetEmptyExt()
- wxFileName::SetName()
- wxFileName::SetVolume()

# File name operations

These methods allow to work with the file creation, access and modification times. Note that not all filesystems under all platforms implement these times in the same way. For example, the access time under Windows has a resolution of one day (so it is really the access date and not time). The access time may be updated when the file is executed or not depending on the platform.

- wxFileName::GetModificationTime()
- wxFileName::GetTimes()
- wxFileName::SetTimes()
- wxFileName::Touch()

Other file system operations functions are:

- wxFileName::Mkdir()
- wxFileName::Rmdir()

# Behavior with symlinks

wxFileName instances can store the path to symlinks on systems that support them. When the path is for a symlink, the behavior of the following methods can be modified to either operate on the symlink itself or on the file the link points to.

- wxFileName::FileExists()
- wxFileName::DirExists()
- wxFileName::Exists()
- wxFileName::SameAs()
- wxFileName::GetTimes()

By default, those functions will operate on the target of the link, but they can be made to operate on the link itself by calling wxFileName::DontFollowLink(). The current link-following mode can be examined by calling wxFileName::ShouldFollowLink().

The wxFileName::ResolveLink() method can be used to get the absolute path for the target of the symlink.

##

Library: wxBase
Category: File Handling

wxString | GetHumanReadableSize (const wxString &failmsg=_("Not available"), int precision=1, wxSizeConvention conv=wxSIZE_CONV_TRADITIONAL) const
| Returns the representation of the file size in a human-readable form. More...
static wxString | GetHumanReadableSize (const wxULongLong &bytes, const wxString &nullsize=_("Not available"), int precision=1, wxSizeConvention conv=wxSIZE_CONV_TRADITIONAL)
| Returns the representation of the file size in a human-readable form. More...

## Public Member Functions
| wxFileName ()
| Default constructor. More...
| wxFileName (const wxFileName &filename)
| Copy constructor. More...
| wxFileName (const wxString &fullpath, wxPathFormat format=wxPATH_NATIVE)
| Constructor taking a full filename. More...
| wxFileName (const wxString &path, const wxString &name, wxPathFormat format=wxPATH_NATIVE)
| Constructor a directory name and file name. More...
| wxFileName (const wxString &path, const wxString &name, const wxString &ext, wxPathFormat format=wxPATH_NATIVE)
| Constructor from a directory name, base file name and extension. More...
| wxFileName (const wxString &volume, const wxString &path, const wxString &name, const wxString &ext, wxPathFormat format=wxPATH_NATIVE)
| Constructor from a volume name, a directory name, base file name and extension. More...
bool | AppendDir (const wxString &dir)
| Appends a directory component to the path. More...
void | Assign (const wxFileName &filepath)
| Creates the file name from another filename object. More...
void | Assign (const wxString &fullpath, wxPathFormat format=wxPATH_NATIVE)
| Creates the file name from a full file name with a path. More...
void | Assign (const wxString &volume, const wxString &path, const wxString &name, const wxString &ext, bool hasExt, wxPathFormat format=wxPATH_NATIVE)
| Creates the file name from volume, path, name and extension. More...
void | Assign (const wxString &volume, const wxString &path, const wxString &name, const wxString &ext, wxPathFormat format=wxPATH_NATIVE)
| Creates the file name from volume, path, name and extension. More...
void | Assign (const wxString &path, const wxString &name, wxPathFormat format=wxPATH_NATIVE)
| Creates the file name from file path and file name. More...
void | Assign (const wxString &path, const wxString &name, const wxString &ext, wxPathFormat format=wxPATH_NATIVE)
| Creates the file name from path, name and extension. More...
void | AssignCwd (const wxString &volume=wxEmptyString)
| Makes this object refer to the current working directory on the specified volume (or current volume if volume is empty). More...
void | AssignDir (const wxString &dir, wxPathFormat format=wxPATH_NATIVE)
| Sets this file name object to the given directory name. More...
void | AssignHomeDir ()
| Sets this file name object to the home directory. More...
void | AssignTempFileName (const wxString &prefix)
| The function calls CreateTempFileName() to create a temporary file and sets this object to the name of the file. More...
void | AssignTempFileName (const wxString &prefix, wxFile *fileTemp)
| The function calls CreateTempFileName() to create a temporary file name and open fileTemp with it. More...
void | AssignTempFileName (const wxString &prefix, wxFFile *fileTemp)
| The function calls CreateTempFileName() to create a temporary file name and open fileTemp with it. More...
void | Clear ()
| Reset all components to default, uninitialized state. More...
void | ClearExt ()
| Removes the extension from the file name resulting in a file name with no trailing dot. More...
bool | DirExists () const
| Returns true if the directory with this name exists. More...
void | DontFollowLink ()
| Turns off symlink dereferencing. More...
bool | Exists (int flags=wxFILE_EXISTS_ANY) const
| Calls the static overload of this function with the full path of this object. More...
bool | FileExists () const
| Returns true if the file with this name exists. More...
wxString | GetAbsolutePath (const wxString &cwd=wxEmptyString, wxPathFormat format=wxPATH_NATIVE) const
| Returns full absolute path for this file. More...
size_t | GetDirCount () const
| Returns the number of directories in the file name. More...
const wxArrayString & | GetDirs () const
| Returns the directories in string array form. More...
wxString | GetExt () const
| Returns the file name extension. More...
wxString | GetFullName () const
| Returns the full name (including extension but excluding directories). More...
wxString | GetFullPath (wxPathFormat format=wxPATH_NATIVE) const
| Returns the full path with name and extension. More...
wxString | GetLongPath () const
| Return the long form of the path (returns identity on non-Windows platforms). More...
wxDateTime | GetModificationTime () const
| Returns the last time the file was last modified. More...
wxString | GetName () const
| Returns the name part of the filename (without extension). More...
wxString | GetPath (int flags=wxPATH_GET_VOLUME, wxPathFormat format=wxPATH_NATIVE) const
| Returns the path part of the filename (without the name or extension). More...
wxString | GetPathWithSep (wxPathFormat format=wxPATH_NATIVE) const
| Returns the path with the trailing separator, useful for appending the name to the given path. More...
wxString | GetShortPath () const
| Return the short form of the path (returns identity on non-Windows platforms). More...
wxULongLong | GetSize () const
| Returns the size of the file If the file does not exist or its size could not be read (because e.g. More...
bool | GetTimes (wxDateTime *dtAccess, wxDateTime *dtMod, wxDateTime *dtCreate) const
| Returns the last access, last modification and creation times. More...
wxString | GetVolume () const
| Returns the string containing the volume for this file name. More...
bool | HasExt () const
| Returns true if an extension is present. More...
bool | HasName () const
| Returns true if a name is present. More...
bool | HasVolume () const
| Returns true if a volume specifier is present. More...
bool | InsertDir (size_t before, const wxString &dir)
| Inserts a directory component before the zero-based position in the directory list. More...
bool | IsAbsolute (wxPathFormat format=wxPATH_NATIVE) const
| Returns true if this filename is absolute. More...
bool | IsDir () const
| Returns true if this object represents a directory, false otherwise (i.e. More...
bool | IsDirReadable () const
| Returns true if the directory component of this instance is an existing directory and this process has read permissions on it. More...
bool | IsDirWritable () const
| Returns true if the directory component of this instance is an existing directory and this process has write permissions on it. More...
bool | IsFileExecutable () const
| Returns true if a file with this name exists and if this process has execute permissions on it. More...
bool | IsFileReadable () const
| Returns true if a file with this name exists and if this process has read permissions on it. More...
bool | IsFileWritable () const
| Returns true if a file with this name exists and if this process has write permissions on it. More...
bool | IsOk () const
| Returns true if the filename is valid, false if it is not initialized yet. More...
bool | IsRelative (wxPathFormat format=wxPATH_NATIVE) const
| Returns true if this filename is not absolute. More...
bool | MakeAbsolute (const wxString &cwd=wxEmptyString, wxPathFormat format=wxPATH_NATIVE)
| Make the file name absolute. More...
bool | MakeRelativeTo (const wxString &pathBase=wxEmptyString, wxPathFormat format=wxPATH_NATIVE)
| This function tries to put this file name in a form relative to pathBase. More...
bool | Mkdir (int perm=wxS_DIR_DEFAULT, int flags=0) const
| Creates a directory. More...
bool | Normalize (int flags, const wxString &cwd=wxEmptyString, wxPathFormat format=wxPATH_NATIVE)
| Normalize the path. More...
void | PrependDir (const wxString &dir)
| Prepends a directory to the file path. More...
void | RemoveDir (size_t pos)
| Removes the specified directory component from the path. More...
void | RemoveLastDir ()
| Removes last directory component from the path. More...
bool | ReplaceEnvVariable (const wxString &envname, const wxString &replacementFmtString="$%s", wxPathFormat format=wxPATH_NATIVE)
| If the path contains the value of the environment variable named envname then this function replaces it with the string obtained from wxString::Format(replacementFmtString, value_of_envname_variable). More...
bool | ReplaceHomeDir (wxPathFormat format=wxPATH_NATIVE)
| Replaces, if present in the path, the home directory for the given user (see wxGetHomeDir) with a tilde (~). More...
wxFileName | ResolveLink ()
| Find the absolute path of the file/directory that is pointed to by this path. More...
bool | Rmdir (int flags=0) const
| Deletes the specified directory from the file system. More...
bool | SameAs (const wxFileName &filepath, wxPathFormat format=wxPATH_NATIVE) const
| Compares the filename using the rules of this platform. More...
bool | SetCwd () const
| Changes the current working directory. More...
void | SetEmptyExt ()
| Sets the extension of the file name to be an empty extension. More...
void | SetExt (const wxString &ext)
| Sets the extension of the file name. More...
void | SetFullName (const wxString &fullname)
| The full name is the file name and extension (but without the path). More...
void | SetName (const wxString &name)
| Sets the name part (without extension). More...
void | SetPath (const wxString &path, wxPathFormat format=wxPATH_NATIVE)
| Sets the path. More...
bool | SetPermissions (int permissions)
| Sets permissions for this file or directory. More...
bool | SetTimes (const wxDateTime *dtAccess, const wxDateTime *dtMod, const wxDateTime *dtCreate) const
| Sets the file creation and last access/modification times (any of the pointers may be nullptr). More...
void | SetVolume (const wxString &volume)
| Sets the volume specifier. More...
bool | ShouldFollowLink () const
| Return whether some operations will follow symlink. More...
bool | Touch () const
| Sets the access and modification times to the current moment. More...
bool | operator!= (const wxFileName &filename) const
| Returns true if the filenames are different. More...
bool | operator!= (const wxString &filename) const
| Returns true if the filenames are different. More...
bool | operator== (const wxFileName &filename) const
| Returns true if the filenames are equal. More...
bool | operator== (const wxString &filename) const
| Returns true if the filenames are equal. More...
wxFileName & | operator= (const wxFileName &filename)
| Assigns the new value to this filename object. More...
wxFileName & | operator= (const wxString &filename)
| Assigns the new value to this filename object. More...

## Static Public Member Functions
static wxString | CreateTempFileName (const wxString &prefix, wxFile *fileTemp=nullptr)
| Returns a temporary file name starting with the given prefix. More...
static wxString | CreateTempFileName (const wxString &prefix, wxFFile *fileTemp=nullptr)
| This is the same as CreateTempFileName(const wxString &prefix, wxFile *fileTemp) but takes a wxFFile parameter instead of wxFile. More...
static bool | DirExists (const wxString &dir)
| Returns true if the directory with name dir exists. More...
static wxFileName | DirName (const wxString &dir, wxPathFormat format=wxPATH_NATIVE)
| Returns the object corresponding to the directory with the given name. More...
static bool | Exists (const wxString &path, int flags=wxFILE_EXISTS_ANY)
| Returns true if either a file or a directory or something else with this name exists in the file system. More...
static bool | FileExists (const wxString &file)
| Returns true if the file with name file exists. More...
static wxFileName | FileName (const wxString &file, wxPathFormat format=wxPATH_NATIVE)
| Returns the file name object corresponding to the given file. More...
static wxString | GetCwd (const wxString &volume=wxEmptyString)
| Retrieves the value of the current working directory on the specified volume. More...
static wxString | GetForbiddenChars (wxPathFormat format=wxPATH_NATIVE)
| Returns the characters that can't be used in filenames and directory names for the specified format. More...
static wxPathFormat | GetFormat (wxPathFormat format=wxPATH_NATIVE)
| Returns the canonical path format for this platform. More...
static wxString | GetHomeDir ()
| Returns the home directory. More...
static wxUniChar | GetPathSeparator (wxPathFormat format=wxPATH_NATIVE)
| Returns the usually used path separator for this format. More...
static wxString | GetPathSeparators (wxPathFormat format=wxPATH_NATIVE)
| Returns the string containing all the path separators for this format. More...
static wxString | GetPathTerminators (wxPathFormat format=wxPATH_NATIVE)
| Returns the string of characters which may terminate the path part. More...
static wxULongLong | GetSize (const wxString &filename)
| Returns the size of the file If the file does not exist or its size could not be read (because e.g. More...
static wxString | GetTempDir ()
| Returns the directory used for temporary files, for current user. More...
static wxString | GetVolumeSeparator (wxPathFormat format=wxPATH_NATIVE)
| Returns the string separating the volume from the path for this format. More...
static wxString | GetVolumeString (char drive, int flags=wxPATH_GET_SEPARATOR)
| This function builds a volume path string, for example "C:\\". More...
static bool | IsCaseSensitive (wxPathFormat format=wxPATH_NATIVE)
| Returns true if the file names of this type are case-sensitive. More...
static bool | IsDirReadable (const wxString &dir)
| Returns true if the given dir is an existing directory and this process has read permissions on it. More...
static bool | IsDirWritable (const wxString &dir)
| Returns true if the given dir is an existing directory and this process has write permissions on it. More...
static bool | IsFileExecutable (const wxString &file)
| Returns true if a file with this name exists and if this process has execute permissions on it. More...
static bool | IsFileReadable (const wxString &file)
| Returns true if a file with this name exists and if this process has read permissions on it. More...
static bool | IsFileWritable (const wxString &file)
| Returns true if a file with this name exists and if this process has write permissions on it. More...
static bool | IsPathSeparator (wxChar ch, wxPathFormat format=wxPATH_NATIVE)
| Returns true if the char is a path separator for this format. More...
static bool | IsMSWExtendedLengthPath (const wxString &path, wxPathFormat format=wxPATH_NATIVE)
| Returns true if the path starts with a double backslash and a question mark. More...
static bool | IsMSWUniqueVolumeNamePath (const wxString &path, wxPathFormat format=wxPATH_NATIVE)
| Returns true if the volume part of the path is a unique volume name. More...
static bool | Mkdir (const wxString &dir, int perm=wxS_DIR_DEFAULT, int flags=0)
| Creates a directory. More...
static bool | Rmdir (const wxString &dir, int flags=0)
| Deletes the specified directory from the file system. More...
static bool | SetCwd (const wxString &cwd)
| Changes the current working directory. More...
static wxFileName | URLToFileName (const wxString &url)
| Converts URL into a well-formed filename. More...
static wxString | FileNameToURL (const wxFileName &filename)
| Converts wxFileName into an URL. More...
static void | SplitVolume (const wxString &fullpath, wxString *volume, wxString *path, wxPathFormat format=wxPATH_NATIVE)
| Splits the given fullpath into the volume part (which may be empty) and the pure path part, not containing any volume. More...
static wxString | StripExtension (const wxString &fullname)
| Strip the file extension. More...
static void | SplitPath (const wxString &fullpath, wxString *volume, wxString *path, wxString *name, wxString *ext, bool *hasExt=nullptr, wxPathFormat format=wxPATH_NATIVE)
| This function splits a full file name into components: the volume (with the first version) path (including the volume in the second version), the base name and the extension. More...
static void | SplitPath (const wxString &fullpath, wxString *volume, wxString *path, wxString *name, wxString *ext, wxPathFormat format)
| This function splits a full file name into components: the volume (with the first version) path (including the volume in the second version), the base name and the extension. More...
static void | SplitPath (const wxString &fullpath, wxString *path, wxString *name, wxString *ext, wxPathFormat format=wxPATH_NATIVE)
| This function splits a full file name into components: the volume (with the first version) path (including the volume in the second version), the base name and the extension. More...

## Constructor & Destructor Documentation

## ◆ wxFileName() [1/6]

wxFileName::wxFileName | ( |  | ) |

Default constructor.

## ◆ wxFileName() [2/6]

wxFileName::wxFileName | ( | const wxFileName & | filename | ) |

Copy constructor.

## ◆ wxFileName() [3/6]

wxFileName::wxFileName | ( | const wxString & | fullpath,
|  | wxPathFormat | format = `wxPATH_NATIVE`
| ) |  |

Constructor taking a full filename.

If it terminates with a '/', a directory path is constructed (the name will be empty), otherwise a file name and extension are extracted from it.

## ◆ wxFileName() [4/6]

wxFileName::wxFileName | ( | const wxString & | path,
|  | const wxString & | name,
|  | wxPathFormat | format = `wxPATH_NATIVE`
| ) |  |

Constructor a directory name and file name.

## ◆ wxFileName() [5/6]

wxFileName::wxFileName | ( | const wxString & | path,
|  | const wxString & | name,
|  | const wxString & | ext,
|  | wxPathFormat | format = `wxPATH_NATIVE`
| ) |  |

Constructor from a directory name, base file name and extension.

## ◆ wxFileName() [6/6]

wxFileName::wxFileName | ( | const wxString & | volume,
|  | const wxString & | path,
|  | const wxString & | name,
|  | const wxString & | ext,
|  | wxPathFormat | format = `wxPATH_NATIVE`
| ) |  |

Constructor from a volume name, a directory name, base file name and extension.

## Member Function Documentation

## ◆ AppendDir()

bool wxFileName::AppendDir | ( | const wxString & | dir | ) |

Appends a directory component to the path.

This component should contain a single directory name level, i.e. not contain any path or volume separators nor should it be empty, otherwise the function does nothing and returns false (and generates an assert failure in debug build).

Notice that the return value is only available in wxWidgets 2.9.5 or later.

## ◆ Assign() [1/6]

void wxFileName::Assign | ( | const wxFileName & | filepath | ) |

Creates the file name from another filename object.

## ◆ Assign() [2/6]

void wxFileName::Assign | ( | const wxString & | fullpath,
|  | wxPathFormat | format = `wxPATH_NATIVE`
| ) |  |

Creates the file name from a full file name with a path.

## ◆ Assign() [3/6]

void wxFileName::Assign | ( | const wxString & | path,
|  | const wxString & | name,
|  | const wxString & | ext,
|  | wxPathFormat | format = `wxPATH_NATIVE`
| ) |  |

Creates the file name from path, name and extension.

## ◆ Assign() [4/6]

void wxFileName::Assign | ( | const wxString & | path,
|  | const wxString & | name,
|  | wxPathFormat | format = `wxPATH_NATIVE`
| ) |  |

Creates the file name from file path and file name.

## ◆ Assign() [5/6]

void wxFileName::Assign | ( | const wxString & | volume,
|  | const wxString & | path,
|  | const wxString & | name,
|  | const wxString & | ext,
|  | bool | hasExt,
|  | wxPathFormat | format = `wxPATH_NATIVE`
| ) |  |

Creates the file name from volume, path, name and extension.

## ◆ Assign() [6/6]

void wxFileName::Assign | ( | const wxString & | volume,
|  | const wxString & | path,
|  | const wxString & | name,
|  | const wxString & | ext,
|  | wxPathFormat | format = `wxPATH_NATIVE`
| ) |  |

Creates the file name from volume, path, name and extension.

## ◆ AssignCwd()

void wxFileName::AssignCwd | ( | const wxString & | volume = `wxEmptyString` | ) |

Makes this object refer to the current working directory on the specified volume (or current volume if volume is empty).

See also
  GetCwd()

## ◆ AssignDir()

void wxFileName::AssignDir | ( | const wxString & | dir,
|  | wxPathFormat | format = `wxPATH_NATIVE`
| ) |  |

Sets this file name object to the given directory name.

The name and extension will be empty.

## ◆ AssignHomeDir()

void wxFileName::AssignHomeDir | ( |  | ) |

Sets this file name object to the home directory.

## ◆ AssignTempFileName() [1/3]

void wxFileName::AssignTempFileName | ( | const wxString & | prefix | ) |

The function calls CreateTempFileName() to create a temporary file and sets this object to the name of the file.

If a temporary file couldn't be created, the object is put into an invalid state (see IsOk()).

## ◆ AssignTempFileName() [2/3]

void wxFileName::AssignTempFileName | ( | const wxString & | prefix,
|  | wxFFile * | fileTemp
| ) |  |

The function calls CreateTempFileName() to create a temporary file name and open fileTemp with it.

If the file couldn't be opened, the object is put into an invalid state (see IsOk()).

## ◆ AssignTempFileName() [3/3]

void wxFileName::AssignTempFileName | ( | const wxString & | prefix,
|  | wxFile * | fileTemp
| ) |  |

The function calls CreateTempFileName() to create a temporary file name and open fileTemp with it.

If the file couldn't be opened, the object is put into an invalid state (see IsOk()).

## ◆ Clear()

void wxFileName::Clear | ( |  | ) |

Reset all components to default, uninitialized state.

## ◆ ClearExt()

void wxFileName::ClearExt | ( |  | ) |

Removes the extension from the file name resulting in a file name with no trailing dot.

See also
  SetExt(), SetEmptyExt()

## ◆ CreateTempFileName() [1/2]

static wxString wxFileName::CreateTempFileName | ( | const wxString & | prefix,
|  | wxFFile * | fileTemp = `nullptr`
| ) |  |
| static

This is the same as CreateTempFileName(const wxString &prefix, wxFile *fileTemp) but takes a wxFFile parameter instead of wxFile.

## ◆ CreateTempFileName() [2/2]

static wxString wxFileName::CreateTempFileName | ( | const wxString & | prefix,
|  | wxFile * | fileTemp = `nullptr`
| ) |  |
| static

Returns a temporary file name starting with the given prefix.

If prefix is an absolute path and ends in a separator, the temporary file is created in this directory; if it is an absolute filepath or there is no separator, the temporary file is created in its path, with the 'name' segment prepended to the temporary filename; otherwise it is created in the default system directory for temporary files or in the current directory.

If the function succeeds, the temporary file is actually created. If fileTemp is not nullptr, this wxFile will be opened using the name of the temporary file. Where possible this is done in an atomic way to ensure that no race condition occurs between creating the temporary file name and opening it, which might lead to a security compromise on multiuser systems. If fileTemp is nullptr, the file is created but not opened. Under Unix, the temporary file will have read and write permissions for the owner only, to minimize security problems.

Parameters

  prefix | Location to use for the temporary file name construction. If prefix is a directory it must have a terminal separator
  fileTemp | The file to open, or nullptr just to get the name

Returns
  The full temporary filepath, or an empty string on error.

## ◆ DirExists() [1/2]

bool wxFileName::DirExists | ( |  | ) | const

Returns true if the directory with this name exists.

Notice that this function tests the directory part of this object, i.e. the string returned by GetPath(), and not the full path returned by GetFullPath().

See also
  FileExists(), Exists()

## ◆ DirExists() [2/2]

static bool wxFileName::DirExists | ( | const wxString & | dir | ) |
| static

Returns true if the directory with name dir exists.

See also
  FileExists(), Exists()

## ◆ DirName()

static wxFileName wxFileName::DirName | ( | const wxString & | dir,
|  | wxPathFormat | format = `wxPATH_NATIVE`
| ) |  |
| static

Returns the object corresponding to the directory with the given name.

The dir parameter may have trailing path separator or not.

## ◆ DontFollowLink()

void wxFileName::DontFollowLink | ( |  | ) |

Turns off symlink dereferencing.

By default, all operations in this class work on the target of a symbolic link (symlink) if the path of the file is actually a symlink. Using this method allows turning off this "symlink following" behaviour and apply the operations to this path itself, even if it is a symlink.

The following methods are currently affected by this option:

- GetTimes() (but not SetTimes() as there is no portable way to change the time of symlink itself).
- Existence checks: FileExists(), DirExists() and Exists() (notice that static versions of these methods always follow symlinks).
- IsSameAs().

See also
  ShouldFollowLink()

Since
  2.9.5

## ◆ Exists() [1/2]

static bool wxFileName::Exists | ( | const wxString & | path,
|  | int | flags = `wxFILE_EXISTS_ANY`
| ) |  |
| static

Returns true if either a file or a directory or something else with this name exists in the file system.

Don't dereference path if it is a symbolic link and flags argument contains wxFILE_EXISTS_NO_FOLLOW.

This method is equivalent to

FileExists() || DirExists()
wxFileName::FileExists
bool FileExists() const
Returns true if the file with this name exists.
wxFileName::DirExists
bool DirExists() const
Returns true if the directory with this name exists.

under Windows, but under Unix it also returns true if the file identifies a special file system object such as a device, a socket or a FIFO.

Alternatively you may check for the existence of a file system entry of a specific type by passing the appropriate flags (this parameter is new since wxWidgets 2.9.5). E.g. to test for a symbolic link existence you could use wxFILE_EXISTS_SYMLINK.

Since
  2.9.4

See also
  FileExists(), DirExists()

## ◆ Exists() [2/2]

bool wxFileName::Exists | ( | int | flags = `wxFILE_EXISTS_ANY` | ) | const

Calls the static overload of this function with the full path of this object.

Since
  2.9.4 (flags is new since 2.9.5)

## ◆ FileExists() [1/2]

bool wxFileName::FileExists | ( |  | ) | const

Returns true if the file with this name exists.

See also
  DirExists(), Exists()

## ◆ FileExists() [2/2]

static bool wxFileName::FileExists | ( | const wxString & | file | ) |
| static

Returns true if the file with name file exists.

See also
  DirExists(), Exists()

## ◆ FileName()

static wxFileName wxFileName::FileName | ( | const wxString & | file,
|  | wxPathFormat | format = `wxPATH_NATIVE`
| ) |  |
| static

Returns the file name object corresponding to the given file.

This function exists mainly for symmetry with DirName().

## ◆ FileNameToURL()

static wxString wxFileName::FileNameToURL | ( | const wxFileName & | filename | ) |
| static

Converts wxFileName into an URL.

See also
  URLToFileName(), wxFileName

Since
  3.1.3

## ◆ GetAbsolutePath()

wxString wxFileName::GetAbsolutePath | ( | const wxString & | cwd = `wxEmptyString`,
|  | wxPathFormat | format = `wxPATH_NATIVE`
| ) |  | const

Returns full absolute path for this file.

This is just a convenient shortcut using MakeAbsolute() and GetFullPath() internally.

Since
  3.1.6

## ◆ GetCwd()

static wxString wxFileName::GetCwd | ( | const wxString & | volume = `wxEmptyString` | ) |
| static

Retrieves the value of the current working directory on the specified volume.

If the volume is empty, the program's current working directory is returned for the current volume.

Returns
  The string containing the current working directory or an empty string on error.

See also
  AssignCwd()

## ◆ GetDirCount()

size_t wxFileName::GetDirCount | ( |  | ) | const

Returns the number of directories in the file name.

## ◆ GetDirs()

const wxArrayString& wxFileName::GetDirs | ( |  | ) | const

Returns the directories in string array form.

## ◆ GetExt()

wxString wxFileName::GetExt | ( |  | ) | const

Returns the file name extension.

## ◆ GetForbiddenChars()

static wxString wxFileName::GetForbiddenChars | ( | wxPathFormat | format = `wxPATH_NATIVE` | ) |
| static

Returns the characters that can't be used in filenames and directory names for the specified format.

## ◆ GetFormat()

static wxPathFormat wxFileName::GetFormat | ( | wxPathFormat | format = `wxPATH_NATIVE` | ) |
| static

Returns the canonical path format for this platform.

## ◆ GetFullName()

wxString wxFileName::GetFullName | ( |  | ) | const

Returns the full name (including extension but excluding directories).

## ◆ GetFullPath()

wxString wxFileName::GetFullPath | ( | wxPathFormat | format = `wxPATH_NATIVE` | ) | const

Returns the full path with name and extension.

## ◆ GetHomeDir()

static wxString wxFileName::GetHomeDir | ( |  | ) |
| static

Returns the home directory.

## ◆ GetHumanReadableSize() [1/2]

wxString wxFileName::GetHumanReadableSize | ( | const wxString & | failmsg = `_("Not available")`,
|  | int | precision = `1`,
|  | wxSizeConvention | conv = `wxSIZE_CONV_TRADITIONAL`
| ) |  | const

Returns the representation of the file size in a human-readable form.

In the first version, the size of this file is used. In the second one, the specified size bytes is used.

If the file size could not be retrieved or bytes is wxInvalidSize or zero, the `failmsg` string is returned.

Otherwise the returned string is a floating-point number with `precision` decimal digits followed by the abbreviation of the unit used. By default the traditional, although incorrect, convention of using SI units for multiples of 1024 is used, i.e. returned string will use suffixes of B, KB, MB, GB, TB for bytes, kilobytes, megabytes, gigabytes and terabytes respectively. With the IEC convention the names of the units are changed to B, KiB, MiB, GiB and TiB for bytes, kibibytes, mebibytes, gibibytes and tebibytes. Finally, with SI convention the same B, KB, MB, GB and TB suffixes are used but in their correct SI meaning, i.e. as multiples of 1000 and not 1024.

Support for the different size conventions is new in wxWidgets 2.9.1, in previous versions only the traditional convention was implemented.

## ◆ GetHumanReadableSize() [2/2]

static wxString wxFileName::GetHumanReadableSize | ( | const wxULongLong & | bytes,
|  | const wxString & | nullsize = `_("Not available")`,
|  | int | precision = `1`,
|  | wxSizeConvention | conv = `wxSIZE_CONV_TRADITIONAL`
| ) |  |
| static

Returns the representation of the file size in a human-readable form.

In the first version, the size of this file is used. In the second one, the specified size bytes is used.

If the file size could not be retrieved or bytes is wxInvalidSize or zero, the `failmsg` string is returned.

Otherwise the returned string is a floating-point number with `precision` decimal digits followed by the abbreviation of the unit used. By default the traditional, although incorrect, convention of using SI units for multiples of 1024 is used, i.e. returned string will use suffixes of B, KB, MB, GB, TB for bytes, kilobytes, megabytes, gigabytes and terabytes respectively. With the IEC convention the names of the units are changed to B, KiB, MiB, GiB and TiB for bytes, kibibytes, mebibytes, gibibytes and tebibytes. Finally, with SI convention the same B, KB, MB, GB and TB suffixes are used but in their correct SI meaning, i.e. as multiples of 1000 and not 1024.

Support for the different size conventions is new in wxWidgets 2.9.1, in previous versions only the traditional convention was implemented.

## ◆ GetLongPath()

wxString wxFileName::GetLongPath | ( |  | ) | const

Return the long form of the path (returns identity on non-Windows platforms).

## ◆ GetModificationTime()

wxDateTime wxFileName::GetModificationTime | ( |  | ) | const

Returns the last time the file was last modified.

## ◆ GetName()

wxString wxFileName::GetName | ( |  | ) | const

Returns the name part of the filename (without extension).

See also
  GetFullName()

## ◆ GetPath()

wxString wxFileName::GetPath | ( | int | flags = `wxPATH_GET_VOLUME`,
|  | wxPathFormat | format = `wxPATH_NATIVE`
| ) |  | const

Returns the path part of the filename (without the name or extension).

The possible flags values are:

- wxPATH_GET_VOLUME: Return the path with the volume (does nothing for the filename formats without volumes), otherwise the path without volume part is returned.
- wxPATH_GET_SEPARATOR: Return the path with the trailing separator, if this flag is not given there will be no separator at the end of the path.
- wxPATH_NO_SEPARATOR: Don't include the trailing separator in the returned string. This is the default (the value of this flag is 0) and exists only for symmetry with wxPATH_GET_SEPARATOR.

Note
  If the path is a toplevel one (e.g. `"/"` on Unix or `"C:\"` on Windows), then the returned path will contain trailing separator even with `wxPATH_NO_SEPARATOR`.

## ◆ GetPathSeparator()

static wxUniChar wxFileName::GetPathSeparator | ( | wxPathFormat | format = `wxPATH_NATIVE` | ) |
| static

Returns the usually used path separator for this format.

For all formats but `wxPATH_DOS` there is only one path separator anyhow, but for DOS there are two of them and the native one, i.e. the backslash is returned by this method.

See also
  GetPathSeparators()

## ◆ GetPathSeparators()

static wxString wxFileName::GetPathSeparators | ( | wxPathFormat | format = `wxPATH_NATIVE` | ) |
| static

Returns the string containing all the path separators for this format.

For all formats but `wxPATH_DOS` this string contains only one character but for DOS and Windows both `'/'` and `'\'` may be used as separators.

See also
  GetPathSeparator()

## ◆ GetPathTerminators()

static wxString wxFileName::GetPathTerminators | ( | wxPathFormat | format = `wxPATH_NATIVE` | ) |
| static

Returns the string of characters which may terminate the path part.

This is the same as GetPathSeparators() except for VMS path format where ] is used at the end of the path part.

## ◆ GetPathWithSep()

wxString wxFileName::GetPathWithSep | ( | wxPathFormat | format = `wxPATH_NATIVE` | ) | const

Returns the path with the trailing separator, useful for appending the name to the given path.

This is the same as calling

GetPath(wxPATH_GET_VOLUME | wxPATH_GET_SEPARATOR, format)

## ◆ GetShortPath()

wxString wxFileName::GetShortPath | ( |  | ) | const

Return the short form of the path (returns identity on non-Windows platforms).

## ◆ GetSize() [1/2]

wxULongLong wxFileName::GetSize | ( |  | ) | const

Returns the size of the file If the file does not exist or its size could not be read (because e.g.

the file is locked by another process) the returned value is wxInvalidSize.

## ◆ GetSize() [2/2]

static wxULongLong wxFileName::GetSize | ( | const wxString & | filename | ) |
| static

Returns the size of the file If the file does not exist or its size could not be read (because e.g.

the file is locked by another process) the returned value is wxInvalidSize.

## ◆ GetTempDir()

static wxString wxFileName::GetTempDir | ( |  | ) |
| static

Returns the directory used for temporary files, for current user.

Same as wxStandardPaths::GetTempDir().

## ◆ GetTimes()

bool wxFileName::GetTimes | ( | wxDateTime * | dtAccess,
|  | wxDateTime * | dtMod,
|  | wxDateTime * | dtCreate
| ) |  | const

Returns the last access, last modification and creation times.

The last access time is updated whenever the file is read or written (or executed in the case of Windows), last modification time is only changed when the file is written to. Finally, the creation time is indeed the time when the file was created under Windows and the inode change time under Unix (as it is impossible to retrieve the real file creation time there anyhow) which can also be changed by many operations after the file creation.

If no filename or extension is specified in this instance of wxFileName (and therefore IsDir() returns true) then this function will return the directory times of the path specified by GetPath(), otherwise the file times of the file specified by GetFullPath(). Any of the pointers may be nullptr if the corresponding time is not needed.

Returns
  true on success, false if we failed to retrieve the times.

## ◆ GetVolume()

wxString wxFileName::GetVolume | ( |  | ) | const

Returns the string containing the volume for this file name.

The returned string is empty if this object doesn't have a volume name, as is always the case for the paths in Unix format which don't support volumes at all.

Note that for `wxPATH_DOS` format paths, the returned string may have one of the following forms:

- Just a single letter, for the usual drive letter volumes, e.g. `C`.
- A share name preceded by a double backslash, e.g. `\\share`.
- The first part of a so-called "Windows NT device" path, also called "extended length" path, in the form of `\\.\X:` or a raw volume path, e.g. `\\?\Volume{12345678-9abc-def0-1234-56789abcdef0}`. Such volumes always start with a double backslash and a question mark. See also IsMSWExtendedLengthPath().

## ◆ GetVolumeSeparator()

static wxString wxFileName::GetVolumeSeparator | ( | wxPathFormat | format = `wxPATH_NATIVE` | ) |
| static

Returns the string separating the volume from the path for this format.

Note that for `wxPATH_DOS` paths this string can only be used for single-character volumes representing the drive letters, but not with the UNC or GUID volumes (see their description in GetVolume() documentation). For this reason, its use should be avoided, prefer using wxFileName constructor and Assign() overload taking the volume and the path as separate arguments to combining the volume and the path into a single string using the volume separator between them.

## ◆ GetVolumeString()

static wxString wxFileName::GetVolumeString | ( | char | drive,
|  | int | flags = `wxPATH_GET_SEPARATOR`
| ) |  |
| static

This function builds a volume path string, for example "C:\\".

Implemented for the platforms which use drive letters, i.e. MSW only.

Since
  2.9.0

Parameters

  drive | The drive letter, 'A' through 'Z' or 'a' through 'z'.
  flags | `wxPATH_NO_SEPARATOR` or `wxPATH_GET_SEPARATOR` to omit or include the trailing path separator, the default is to include it.

Returns
  Volume path string.

## ◆ HasExt()

bool wxFileName::HasExt | ( |  | ) | const

Returns true if an extension is present.

## ◆ HasName()

bool wxFileName::HasName | ( |  | ) | const

Returns true if a name is present.

## ◆ HasVolume()

bool wxFileName::HasVolume | ( |  | ) | const

Returns true if a volume specifier is present.

## ◆ InsertDir()

bool wxFileName::InsertDir | ( | size_t | before,
|  | const wxString & | dir
| ) |  |

Inserts a directory component before the zero-based position in the directory list.

As with AppendDir(), dir must be a single directory name and the function returns false and does nothing else if it isn't.

Notice that the return value is only available in wxWidgets 2.9.5 or later.

## ◆ IsAbsolute()

bool wxFileName::IsAbsolute | ( | wxPathFormat | format = `wxPATH_NATIVE` | ) | const

Returns true if this filename is absolute.

## ◆ IsCaseSensitive()

static bool wxFileName::IsCaseSensitive | ( | wxPathFormat | format = `wxPATH_NATIVE` | ) |
| static

Returns true if the file names of this type are case-sensitive.

## ◆ IsDir()

bool wxFileName::IsDir | ( |  | ) | const

Returns true if this object represents a directory, false otherwise (i.e.

if it is a file).

Note that this method doesn't test whether the directory or file really exists, you should use DirExists() or FileExists() for this.

## ◆ IsDirReadable() [1/2]

bool wxFileName::IsDirReadable | ( |  | ) | const

Returns true if the directory component of this instance is an existing directory and this process has read permissions on it.

Read permissions on a directory mean that you can list the directory contents but it doesn't imply that you have read permissions on the files contained.

## ◆ IsDirReadable() [2/2]

static bool wxFileName::IsDirReadable | ( | const wxString & | dir | ) |
| static

Returns true if the given dir is an existing directory and this process has read permissions on it.

Read permissions on a directory mean that you can list the directory contents but it doesn't imply that you have read permissions on the files contained.

## ◆ IsDirWritable() [1/2]

bool wxFileName::IsDirWritable | ( |  | ) | const

Returns true if the directory component of this instance is an existing directory and this process has write permissions on it.

Write permissions on a directory mean that you can create new files in the directory.

## ◆ IsDirWritable() [2/2]

static bool wxFileName::IsDirWritable | ( | const wxString & | dir | ) |
| static

Returns true if the given dir is an existing directory and this process has write permissions on it.

Write permissions on a directory mean that you can create new files in the directory.

## ◆ IsFileExecutable() [1/2]

bool wxFileName::IsFileExecutable | ( |  | ) | const

Returns true if a file with this name exists and if this process has execute permissions on it.

## ◆ IsFileExecutable() [2/2]

static bool wxFileName::IsFileExecutable | ( | const wxString & | file | ) |
| static

Returns true if a file with this name exists and if this process has execute permissions on it.

## ◆ IsFileReadable() [1/2]

bool wxFileName::IsFileReadable | ( |  | ) | const

Returns true if a file with this name exists and if this process has read permissions on it.

## ◆ IsFileReadable() [2/2]

static bool wxFileName::IsFileReadable | ( | const wxString & | file | ) |
| static

Returns true if a file with this name exists and if this process has read permissions on it.

## ◆ IsFileWritable() [1/2]

bool wxFileName::IsFileWritable | ( |  | ) | const

Returns true if a file with this name exists and if this process has write permissions on it.

## ◆ IsFileWritable() [2/2]

static bool wxFileName::IsFileWritable | ( | const wxString & | file | ) |
| static

Returns true if a file with this name exists and if this process has write permissions on it.

## ◆ IsMSWExtendedLengthPath()

static bool wxFileName::IsMSWExtendedLengthPath | ( | const wxString & | path,
|  | wxPathFormat | format = `wxPATH_NATIVE`
| ) |  |
| static

Returns true if the path starts with a double backslash and a question mark.

Such paths are known as "Windows NT device" paths or "extended length" paths and are passed directly to the file system, allowing to access objects not accessible using the normal paths and avoiding the 260 character path length restriction.

Since
  3.3.0

## ◆ IsMSWUniqueVolumeNamePath()

static bool wxFileName::IsMSWUniqueVolumeNamePath | ( | const wxString & | path,
|  | wxPathFormat | format = `wxPATH_NATIVE`
| ) |  |
| static

Returns true if the volume part of the path is a unique volume name.

This function will always return false if the path format is not wxPATH_DOS.

Unique volume names are Windows volume identifiers which remain the same regardless of where the volume is actually mounted. Example of a path using a volume name could be

\\?\Volume{8089d7d7-d0ac-11db-9dd0-806d6172696f}\Program Files\setup.exe

Since
  2.9.1

## ◆ IsOk()

bool wxFileName::IsOk | ( |  | ) | const

Returns true if the filename is valid, false if it is not initialized yet.

The assignment functions and Clear() may reset the object to the uninitialized, invalid state (the former only do it on failure).

## ◆ IsPathSeparator()

static bool wxFileName::IsPathSeparator | ( | wxChar | ch,
|  | wxPathFormat | format = `wxPATH_NATIVE`
| ) |  |
| static

Returns true if the char is a path separator for this format.

## ◆ IsRelative()

bool wxFileName::IsRelative | ( | wxPathFormat | format = `wxPATH_NATIVE` | ) | const

Returns true if this filename is not absolute.

## ◆ MakeAbsolute()

bool wxFileName::MakeAbsolute | ( | const wxString & | cwd = `wxEmptyString`,
|  | wxPathFormat | format = `wxPATH_NATIVE`
| ) |  |

Make the file name absolute.

This is a shortcut for

wxFileName::Normalize(wxPATH_NORM_DOTS | wxPATH_NORM_ABSOLUTE |
wxPATH_NORM_TILDE, cwd, format)
wxFileName::Normalize
bool Normalize(int flags, const wxString &cwd=wxEmptyString, wxPathFormat format=wxPATH_NATIVE)
Normalize the path.
wxPATH_NORM_ABSOLUTE
@ wxPATH_NORM_ABSOLUTE
Make the path absolute.
Definition: filename.h:76
wxPATH_NORM_DOTS
@ wxPATH_NORM_DOTS
Squeeze all ".." and ".".
Definition: filename.h:73
wxPATH_NORM_TILDE
@ wxPATH_NORM_TILDE
Replace "~" and "~user" (Unix only).
Definition: filename.h:74

See also
  MakeRelativeTo(), Normalize(), IsAbsolute()

## ◆ MakeRelativeTo()

bool wxFileName::MakeRelativeTo | ( | const wxString & | pathBase = `wxEmptyString`,
|  | wxPathFormat | format = `wxPATH_NATIVE`
| ) |  |

This function tries to put this file name in a form relative to pathBase.

In other words, it returns the file name which should be used to access this file if the current directory were pathBase.

Parameters

  pathBase | The directory to use as root, current directory is used by default
  format | The file name format, native by default

Returns
  true if the file name has been changed, false if we failed to do anything with it (currently this only happens if the file name is on a volume different from the volume specified by pathBase).

See also
  Normalize()

## ◆ Mkdir() [1/2]

static bool wxFileName::Mkdir | ( | const wxString & | dir,
|  | int | perm = `wxS_DIR_DEFAULT`,
|  | int | flags = `0`
| ) |  |
| static

Creates a directory.

Parameters

  dir | The directory to create
  perm | The permissions for the newly created directory. See the wxPosixPermissions enumeration for more info.
  flags | If the flags contain `wxPATH_MKDIR_FULL` flag, try to create each directory in the path and also don't return an error if the target directory already exists.

Returns
  Returns true if the directory was successfully created, false otherwise.

## ◆ Mkdir() [2/2]

bool wxFileName::Mkdir | ( | int | perm = `wxS_DIR_DEFAULT`,
|  | int | flags = `0`
| ) |  | const

Creates a directory.

Parameters

  perm | The permissions for the newly created directory. See the wxPosixPermissions enumeration for more info.
  flags | If the flags contain `wxPATH_MKDIR_FULL` flag, try to create each directory in the path and also don't return an error if the target directory already exists.

Returns
  Returns true if the directory was successfully created, false otherwise.

## ◆ Normalize()

bool wxFileName::Normalize | ( | int | flags,
|  | const wxString & | cwd = `wxEmptyString`,
|  | wxPathFormat | format = `wxPATH_NATIVE`
| ) |  |

Normalize the path.

With the default flags value, the path will be made absolute, without any ".." and ".", and, for the Unix format paths, any occurrences of tilde (`~`) character will be replaced with the home directory of the user following it.

Notice that in some rare cases normalizing a valid path may result in an invalid wxFileName object. E.g. normalizing "./" path using wxPATH_NORM_DOTS but not wxPATH_NORM_ABSOLUTE will result in a completely empty and thus invalid object. As long as there is a non empty file name the result of normalization will be valid however.

Parameters

  flags | The kind of normalization to do with the file name. It can be any or-combination of the wxPathNormalize enumeration values. These values should be explicitly specified, omitting them uses the deprecated wxPATH_NORM_ALL value which is not recommended, see wxPathNormalize enum for more details.
  cwd | If not empty, this directory will be used instead of current working directory in normalization (see `wxPATH_NORM_ABSOLUTE`).
  format | The file name format to use when processing the paths, native by default.

Returns
  true if normalization was successfully or false otherwise.

## ◆ operator!=() [1/2]

bool wxFileName::operator!= | ( | const wxFileName & | filename | ) | const

Returns true if the filenames are different.

The string filenames is interpreted as a path in the native filename format.

## ◆ operator!=() [2/2]

bool wxFileName::operator!= | ( | const wxString & | filename | ) | const

Returns true if the filenames are different.

The string filenames is interpreted as a path in the native filename format.

## ◆ operator=() [1/2]

wxFileName& wxFileName::operator= | ( | const wxFileName & | filename | ) |

Assigns the new value to this filename object.

## ◆ operator=() [2/2]

wxFileName& wxFileName::operator= | ( | const wxString & | filename | ) |

Assigns the new value to this filename object.

## ◆ operator==() [1/2]

bool wxFileName::operator== | ( | const wxFileName & | filename | ) | const

Returns true if the filenames are equal.

The string filenames is interpreted as a path in the native filename format.

## ◆ operator==() [2/2]

bool wxFileName::operator== | ( | const wxString & | filename | ) | const

Returns true if the filenames are equal.

The string filenames is interpreted as a path in the native filename format.

## ◆ PrependDir()

void wxFileName::PrependDir | ( | const wxString & | dir | ) |

Prepends a directory to the file path.

Please see AppendDir() for important notes.

## ◆ RemoveDir()

void wxFileName::RemoveDir | ( | size_t | pos | ) |

Removes the specified directory component from the path.

See also
  GetDirCount()

## ◆ RemoveLastDir()

void wxFileName::RemoveLastDir | ( |  | ) |

Removes last directory component from the path.

## ◆ ReplaceEnvVariable()

bool wxFileName::ReplaceEnvVariable | ( | const wxString & | envname,
|  | const wxString & | replacementFmtString = `"$%s"`,
|  | wxPathFormat | format = `wxPATH_NATIVE`
| ) |  |

If the path contains the value of the environment variable named envname then this function replaces it with the string obtained from wxString::Format(replacementFmtString, value_of_envname_variable).

This function is useful to make the path shorter or to make it dependent from a certain environment variable. Normalize() with `wxPATH_NORM_ENV_VARS` can perform the opposite of this function (depending on the value of replacementFmtString).

The name and extension of this filename are not modified.

Example:

wxFileName fn("/usr/openwin/lib/someFile");
fn.ReplaceEnvVariable("OPENWINHOME");
// now fn.GetFullPath() == "$OPENWINHOME/lib/someFile"

Since
  2.9.0

Returns
  true if the operation was successful (which doesn't mean that something was actually replaced, just that wxGetEnv didn't fail).

## ◆ ReplaceHomeDir()

bool wxFileName::ReplaceHomeDir | ( | wxPathFormat | format = `wxPATH_NATIVE` | ) |

Replaces, if present in the path, the home directory for the given user (see wxGetHomeDir) with a tilde (~).

Normalize() with `wxPATH_NORM_TILDE` performs the opposite of this function.

The name and extension of this filename are not modified.

Since
  2.9.0

Returns
  true if the operation was successful (which doesn't mean that something was actually replaced, just that wxGetHomeDir didn't fail).

## ◆ ResolveLink()

wxFileName wxFileName::ResolveLink | ( |  | ) |

Find the absolute path of the file/directory that is pointed to by this path.

If this path isn't a symlink, then this function will return the current path. If the path does not exist on disk, An empty wxFileName instance will be returned.

Note
  This is only supported on Unix-like platforms (e.g. wxGTK, wxOSX), on other platforms (e.g. wxMSW) this function just returns the current path.

Since
  3.1.5

Returns
  The absolute path that the current symlink path points to.

## ◆ Rmdir() [1/2]

static bool wxFileName::Rmdir | ( | const wxString & | dir,
|  | int | flags = `0`
| ) |  |
| static

Deletes the specified directory from the file system.

Parameters

  dir | The directory to delete
  flags | With default value, the directory is removed only if it is empty. If wxPATH_RMDIR_FULL is specified, it is removed even if it contains subdirectories, provided that there are no files in neither this directory nor its subdirectories. If flags contains wxPATH_RMDIR_RECURSIVE, then the directory is removed with all the files and directories under it.

Returns
  Returns true if the directory was successfully deleted, false otherwise.

## ◆ Rmdir() [2/2]

bool wxFileName::Rmdir | ( | int | flags = `0` | ) | const

Deletes the specified directory from the file system.

Parameters

  flags | With default value, the directory is removed only if it is empty. If wxPATH_RMDIR_FULL is specified, it is removed even if it contains subdirectories, provided that there are no files in neither this directory nor its subdirectories. If flags contains wxPATH_RMDIR_RECURSIVE, then the directory is removed with all the files and directories under it.

Returns
  Returns true if the directory was successfully deleted, false otherwise.

## ◆ SameAs()

bool wxFileName::SameAs | ( | const wxFileName & | filepath,
|  | wxPathFormat | format = `wxPATH_NATIVE`
| ) |  | const

Compares the filename using the rules of this platform.

## ◆ SetCwd() [1/2]

bool wxFileName::SetCwd | ( |  | ) | const

Changes the current working directory.

## ◆ SetCwd() [2/2]

static bool wxFileName::SetCwd | ( | const wxString & | cwd | ) |
| static

Changes the current working directory.

## ◆ SetEmptyExt()

void wxFileName::SetEmptyExt | ( |  | ) |

Sets the extension of the file name to be an empty extension.

This is different from having no extension at all as the file name will have a trailing dot after a call to this method.

See also
  SetExt(), ClearExt()

## ◆ SetExt()

void wxFileName::SetExt | ( | const wxString & | ext | ) |

Sets the extension of the file name.

Setting an empty string as the extension will remove the extension resulting in a file name without a trailing dot, unlike a call to SetEmptyExt().

See also
  SetEmptyExt(), ClearExt()

## ◆ SetFullName()

void wxFileName::SetFullName | ( | const wxString & | fullname | ) |

The full name is the file name and extension (but without the path).

## ◆ SetName()

void wxFileName::SetName | ( | const wxString & | name | ) |

Sets the name part (without extension).

See also
  SetFullName()

## ◆ SetPath()

void wxFileName::SetPath | ( | const wxString & | path,
|  | wxPathFormat | format = `wxPATH_NATIVE`
| ) |  |

Sets the path.

The path argument includes both the path and the volume, if supported by format.

Calling this function doesn't affect the name and extension components, to change them as well you can use Assign() or just an assignment operator.

See also
  GetPath()

## ◆ SetPermissions()

bool wxFileName::SetPermissions | ( | int | permissions | ) |

Sets permissions for this file or directory.

Parameters

  permissions | The new permissions: this should be a combination of wxPosixPermissions enum elements.

Since
  3.0

Note
  If this is a symbolic link and it should not be followed this call will fail.

Returns
  true on success, false if an error occurred (for example, the file doesn't exist).

## ◆ SetTimes()

bool wxFileName::SetTimes | ( | const wxDateTime * | dtAccess,
|  | const wxDateTime * | dtMod,
|  | const wxDateTime * | dtCreate
| ) |  | const

Sets the file creation and last access/modification times (any of the pointers may be nullptr).

Notice that the file creation time can't be changed under Unix, so dtCreate is ignored there (but true is still returned). Under Windows all three times can be set.

## ◆ SetVolume()

void wxFileName::SetVolume | ( | const wxString & | volume | ) |

Sets the volume specifier.

## ◆ ShouldFollowLink()

bool wxFileName::ShouldFollowLink | ( |  | ) | const

Return whether some operations will follow symlink.

By default, file operations "follow symlink", i.e. operate on its target and not on the symlink itself. See DontFollowLink() for more information.

Since
  2.9.5

## ◆ SplitPath() [1/3]

static void wxFileName::SplitPath | ( | const wxString & | fullpath,
|  | wxString * | path,
|  | wxString * | name,
|  | wxString * | ext,
|  | wxPathFormat | format = `wxPATH_NATIVE`
| ) |  |
| static

This function splits a full file name into components: the volume (with the first version) path (including the volume in the second version), the base name and the extension.

Any of the output parameters (volume, path, name or ext) may be nullptr if you are not interested in the value of a particular component. Also, fullpath may be empty on entry. On return, path contains the file path (without the trailing separator), name contains the file name and ext contains the file extension without leading dot. All three of them may be empty if the corresponding component is. The old contents of the strings pointed to by these parameters will be overwritten in any case (if the pointers are not nullptr).

Note that for a filename "foo." the extension is present, as indicated by the trailing dot, but empty. If you need to cope with such cases, you should use hasExt instead of relying on testing whether ext is empty or not.

## ◆ SplitPath() [2/3]

static void wxFileName::SplitPath | ( | const wxString & | fullpath,
|  | wxString * | volume,
|  | wxString * | path,
|  | wxString * | name,
|  | wxString * | ext,
|  | bool * | hasExt = `nullptr`,
|  | wxPathFormat | format = `wxPATH_NATIVE`
| ) |  |
| static

This function splits a full file name into components: the volume (with the first version) path (including the volume in the second version), the base name and the extension.

Any of the output parameters (volume, path, name or ext) may be nullptr if you are not interested in the value of a particular component. Also, fullpath may be empty on entry. On return, path contains the file path (without the trailing separator), name contains the file name and ext contains the file extension without leading dot. All three of them may be empty if the corresponding component is. The old contents of the strings pointed to by these parameters will be overwritten in any case (if the pointers are not nullptr).

Note that for a filename "foo." the extension is present, as indicated by the trailing dot, but empty. If you need to cope with such cases, you should use hasExt instead of relying on testing whether ext is empty or not.

## ◆ SplitPath() [3/3]

static void wxFileName::SplitPath | ( | const wxString & | fullpath,
|  | wxString * | volume,
|  | wxString * | path,
|  | wxString * | name,
|  | wxString * | ext,
|  | wxPathFormat | format
| ) |  |
| static

This function splits a full file name into components: the volume (with the first version) path (including the volume in the second version), the base name and the extension.

Any of the output parameters (volume, path, name or ext) may be nullptr if you are not interested in the value of a particular component. Also, fullpath may be empty on entry. On return, path contains the file path (without the trailing separator), name contains the file name and ext contains the file extension without leading dot. All three of them may be empty if the corresponding component is. The old contents of the strings pointed to by these parameters will be overwritten in any case (if the pointers are not nullptr).

Note that for a filename "foo." the extension is present, as indicated by the trailing dot, but empty. If you need to cope with such cases, you should use hasExt instead of relying on testing whether ext is empty or not.

## ◆ SplitVolume()

static void wxFileName::SplitVolume | ( | const wxString & | fullpath,
|  | wxString * | volume,
|  | wxString * | path,
|  | wxPathFormat | format = `wxPATH_NATIVE`
| ) |  |
| static

Splits the given fullpath into the volume part (which may be empty) and the pure path part, not containing any volume.

See also
  SplitPath()

## ◆ StripExtension()

static wxString wxFileName::StripExtension | ( | const wxString & | fullname | ) |
| static

Strip the file extension.

This function does more than just removing everything after the last period from the string, for example it will return the string ".vimrc" unchanged because the part after the period is not an extension but the file name in this case. You can use wxString::BeforeLast() to really get just the part before the last period (but notice that that function returns empty string if period is not present at all unlike this function which returns the fullname unchanged in this case).

Parameters

  fullname | File path including name and, optionally, extension.

Returns
  File path without extension

Since
  2.9.0

## ◆ Touch()

bool wxFileName::Touch | ( |  | ) | const

Sets the access and modification times to the current moment.

## ◆ URLToFileName()

static wxFileName wxFileName::URLToFileName | ( | const wxString & | url | ) |
| static

Converts URL into a well-formed filename.

The URL must use the `file` protocol. If the URL does not use `file` protocol wxFileName object may not be good or may not exist

Since
  3.1.3